## fftw3 3.3.8

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (fftw)

if (POLICY CMP0042)
  cmake_policy (SET CMP0042 NEW)
endif ()

option (BUILD_SHARED_LIBS "Build shared libraries" ON)
option (BUILD_TESTS "Build tests" ON)

option (ENABLE_OPENMP "Use OpenMP for multithreading" OFF)
option (ENABLE_THREADS "Use pthread for multithreading" OFF)
option (WITH_COMBINED_THREADS "Merge thread library" OFF)

option (ENABLE_FLOAT "single-precision" OFF)
option (ENABLE_LONG_DOUBLE "long-double precision" OFF)
option (ENABLE_QUAD_PRECISION "quadruple-precision" OFF)

option (ENABLE_SSE "Compile with SSE instruction set support" OFF)
option (ENABLE_SSE2 "Compile with SSE2 instruction set support" OFF)
option (ENABLE_AVX "Compile with AVX instruction set support" OFF)
option (ENABLE_AVX2 "Compile with AVX2 instruction set support" OFF)

option (DISABLE_FORTRAN "Disable Fortran wrapper routines" OFF)

include(GNUInstallDirs)


include (CheckIncludeFile)
check_include_file (alloca.h         HAVE_ALLOCA_H)
check_include_file (altivec.h        HAVE_ALTIVEC_H)
check_include_file (c_asm.h          HAVE_C_ASM_H)
check_include_file (dlfcn.h          HAVE_DLFCN_H)
check_include_file (intrinsics.h     HAVE_INTRINSICS_H)
check_include_file (inttypes.h       HAVE_INTTYPES_H)
check_include_file (libintl.h        HAVE_LIBINTL_H)
check_include_file (limits.h         HAVE_LIMITS_H)
check_include_file (mach/mach_time.h HAVE_MACH_MACH_TIME_H)
check_include_file (malloc.h         HAVE_MALLOC_H)
check_include_file (memory.h         HAVE_MEMORY_H)
check_include_file (stddef.h         HAVE_STDDEF_H)
check_include_file (stdint.h         HAVE_STDINT_H)
check_include_file (stdlib.h         HAVE_STDLIB_H)
check_include_file (string.h         HAVE_STRING_H)
check_include_file (strings.h        HAVE_STRINGS_H)
check_include_file (sys/types.h      HAVE_SYS_TYPES_H)
check_include_file (sys/time.h       HAVE_SYS_TIME_H)
check_include_file (sys/stat.h       HAVE_SYS_STAT_H)
check_include_file (sys/sysctl.h     HAVE_SYS_SYSCTL_H)
check_include_file (time.h           HAVE_TIME_H)
check_include_file (uintptr.h        HAVE_UINTPTR_H)
check_include_file (unistd.h         HAVE_UNISTD_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()

include (CheckPrototypeDefinition) 
check_prototype_definition (drand48 "double drand48 (void)" "0" stdlib.h HAVE_DECL_DRAND48)
check_prototype_definition (srand48 "void srand48(long int seedval)" "0" stdlib.h HAVE_DECL_SRAND48)
check_prototype_definition (cosl "long double cosl( long double arg )" "0" math.h HAVE_DECL_COSL)
check_prototype_definition (sinl "long double sinl( long double arg )" "0" math.h HAVE_DECL_SINL)
check_prototype_definition (memalign "void *memalign(size_t alignment, size_t size)" "0" malloc.h HAVE_DECL_MEMALIGN)
check_prototype_definition (posix_memalign "int posix_memalign(void **memptr, size_t alignment, size_t size)" "0" stdlib.h HAVE_DECL_POSIX_MEMALIGN)

include (CheckSymbolExists)
check_symbol_exists (clock_gettime time.h HAVE_CLOCK_GETTIME)
check_symbol_exists (gettimeofday sys/time.h HAVE_GETTIMEOFDAY)
check_symbol_exists (getpagesize unistd.h HAVE_GETPAGESIZE)
check_symbol_exists (drand48 stdlib.h HAVE_DRAND48)
check_symbol_exists (srand48 stdlib.h HAVE_SRAND48)
check_symbol_exists (memalign malloc.h HAVE_MEMALIGN)
check_symbol_exists (posix_memalign stdlib.h HAVE_POSIX_MEMALIGN)
check_symbol_exists (mach_absolute_time mach/mach_time.h HAVE_MACH_ABSOLUTE_TIME)
check_symbol_exists (alloca alloca.h HAVE_ALLOCA)
if (NOT HAVE_ALLOCA)
  unset (HAVE_ALLOCA CACHE)
  check_symbol_exists (alloca malloc.h HAVE_ALLOCA)
endif ()
check_symbol_exists (isnan math.h HAVE_ISNAN)
check_symbol_exists (snprintf stdio.h HAVE_SNPRINTF)
check_symbol_exists (strchr string.h HAVE_STRCHR)
check_symbol_exists (sysctl unistd.h HAVE_SYSCTL)

if (UNIX)
  set (CMAKE_REQUIRED_LIBRARIES m)
endif ()
check_symbol_exists (cosl math.h HAVE_COSL)
check_symbol_exists (sinl math.h HAVE_SINL)

include (CheckTypeSize)
check_type_size ("float" SIZEOF_FLOAT)
check_type_size ("double" SIZEOF_DOUBLE)
check_type_size ("int" SIZEOF_INT)
check_type_size ("long" SIZEOF_LONG)
check_type_size ("long long" SIZEOF_LONG_LONG)
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size ("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
check_type_size ("size_t" SIZEOF_SIZE_T)
check_type_size ("ptrdiff_t" SIZEOF_PTRDIFF_T)
math (EXPR SIZEOF_INT_BITS "8 * ${SIZEOF_INT}")
set (C_FFTW_R2R_KIND "C_INT${SIZEOF_INT_BITS}_T")

find_library (LIBM_LIBRARY NAMES m)
if (LIBM_LIBRARY)
  set (HAVE_LIBM TRUE)
endif ()


if (ENABLE_THREADS)
  find_package (Threads)
endif ()
if (Threads_FOUND)
  if(CMAKE_USE_PTHREADS_INIT)
    set (USING_POSIX_THREADS 1)
  endif ()
  set (HAVE_THREADS TRUE)
endif ()

if (ENABLE_OPENMP)
  find_package (OpenMP)
endif ()
if (OPENMP_FOUND)
  set (HAVE_OPENMP TRUE)
endif ()

include (CheckCCompilerFlag)

if (ENABLE_SSE)
  foreach (FLAG "-msse" "/arch:SSE")
    unset (HAVE_SSE CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE)
    if (HAVE_SSE)
      set (SSE_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_SSE2)
  foreach (FLAG "-msse2" "/arch:SSE2")
    unset (HAVE_SSE2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE2)
    if (HAVE_SSE2)
      set (SSE2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX)
  foreach (FLAG "-mavx" "/arch:AVX")
    unset (HAVE_AVX CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX)
    if (HAVE_AVX)
      set (AVX_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX2)
  foreach (FLAG "-mavx2" "/arch:AVX2")
    unset (HAVE_AVX2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX2)
    if (HAVE_AVX2)
      set (AVX2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

# AVX2 codelets require FMA support as well
if (ENABLE_AVX2)
  foreach (FLAG "-mfma" "/arch:FMA")
    unset (HAVE_FMA CACHE)
    check_c_compiler_flag (${FLAG} HAVE_FMA)
    if (HAVE_FMA)
      set (FMA_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (HAVE_SSE2 OR HAVE_AVX)
  set (HAVE_SIMD TRUE)
endif ()
file(GLOB           fftw_api_SOURCE                 api/*.c             api/*.h)
file(GLOB           fftw_dft_SOURCE                 dft/*.c             dft/*.h)
file(GLOB           fftw_dft_scalar_SOURCE          dft/scalar/*.c      dft/scalar/*.h)
file(GLOB           fftw_dft_scalar_codelets_SOURCE dft/scalar/codelets/*.c     dft/scalar/codelets/*.h)
file(GLOB           fftw_dft_simd_SOURCE            dft/simd/*.c        dft/simd/*.h)

file(GLOB           fftw_dft_simd_sse2_SOURCE       dft/simd/sse2/*.c   dft/simd/sse2/*.h)
file(GLOB           fftw_dft_simd_avx_SOURCE        dft/simd/avx/*.c    dft/simd/avx/*.h)
file(GLOB           fftw_dft_simd_avx2_SOURCE       dft/simd/avx2/*.c   dft/simd/avx2/*.h dft/simd/avx2-128/*.c   dft/simd/avx2-128/*.h)
file(GLOB           fftw_kernel_SOURCE              kernel/*.c          kernel/*.h)
file(GLOB           fftw_rdft_SOURCE                rdft/*.c            rdft/*.h)
file(GLOB           fftw_rdft_scalar_SOURCE         rdft/scalar/*.c     rdft/scalar/*.h)

file(GLOB           fftw_rdft_scalar_r2cb_SOURCE    rdft/scalar/r2cb/*.c
                                                    rdft/scalar/r2cb/*.h)
file(GLOB           fftw_rdft_scalar_r2cf_SOURCE    rdft/scalar/r2cf/*.c
                                                    rdft/scalar/r2cf/*.h)
file(GLOB           fftw_rdft_scalar_r2r_SOURCE     rdft/scalar/r2r/*.c
                                                    rdft/scalar/r2r/*.h)

file(GLOB           fftw_rdft_simd_SOURCE           rdft/simd/*.c       rdft/simd/*.h)
file(GLOB           fftw_rdft_simd_sse2_SOURCE      rdft/simd/sse2/*.c  rdft/simd/sse2/*.h)
file(GLOB           fftw_rdft_simd_avx_SOURCE       rdft/simd/avx/*.c   rdft/simd/avx/*.h)
file(GLOB           fftw_rdft_simd_avx2_SOURCE      rdft/simd/avx2/*.c  rdft/simd/avx2/*.h rdft/simd/avx2-128/*.c  rdft/simd/avx2-128/*.h)

file(GLOB           fftw_reodft_SOURCE              reodft/*.c          reodft/*.h)
file(GLOB           fftw_simd_support_SOURCE        simd-support/*.c    simd-support/*.h)
file(GLOB           fftw_libbench2_SOURCE           libbench2/*.c       libbench2/*.h)
list (REMOVE_ITEM   fftw_libbench2_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/libbench2/useropt.c)

set(SOURCEFILES
    ${fftw_api_SOURCE}
    ${fftw_dft_SOURCE}
    ${fftw_dft_scalar_SOURCE}
    ${fftw_dft_scalar_codelets_SOURCE}
    ${fftw_dft_simd_SOURCE}
    ${fftw_kernel_SOURCE}
    ${fftw_rdft_SOURCE}
    ${fftw_rdft_scalar_SOURCE}

    ${fftw_rdft_scalar_r2cb_SOURCE}
    ${fftw_rdft_scalar_r2cf_SOURCE}
    ${fftw_rdft_scalar_r2r_SOURCE}

    ${fftw_rdft_simd_SOURCE}
    ${fftw_reodft_SOURCE}
    ${fftw_simd_support_SOURCE}
    ${fftw_threads_SOURCE}
)

set(fftw_par_SOURCE
    threads/api.c
    threads/conf.c
    threads/ct.c
    threads/dft-vrank-geq1.c
    threads/f77api.c
    threads/hc2hc.c
    threads/rdft-vrank-geq1.c
    threads/vrank-geq1-rdft2.c)

set (fftw_threads_SOURCE ${fftw_par_SOURCE} threads/threads.c)
set (fftw_omp_SOURCE ${fftw_par_SOURCE} threads/openmp.c)


include_directories (.)


if (WITH_COMBINED_THREADS)
  list (APPEND SOURCEFILES ${fftw_threads_SOURCE})
endif ()


if (HAVE_SSE2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_sse2_SOURCE} ${fftw_rdft_simd_sse2_SOURCE})
endif ()

if (HAVE_AVX)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx_SOURCE} ${fftw_rdft_simd_avx_SOURCE})
endif ()

if (HAVE_AVX2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx2_SOURCE} ${fftw_rdft_simd_avx2_SOURCE})
endif ()

set (FFTW_VERSION 3.3.7)

set (PREC_SUFFIX)
if (ENABLE_FLOAT)
  set (FFTW_SINGLE TRUE)
  set (BENCHFFT_SINGLE TRUE)
  set (PREC_SUFFIX f)
endif ()

if (ENABLE_LONG_DOUBLE)
  set (FFTW_LDOUBLE TRUE)
  set (BENCHFFT_LDOUBLE TRUE)
  set (PREC_SUFFIX l)
endif ()

if (ENABLE_QUAD_PRECISION)
  set (FFTW_QUAD TRUE)
  set (BENCHFFT_QUAD TRUE)
  set (PREC_SUFFIX q)
endif ()
set (fftw3_lib fftw3${PREC_SUFFIX})

configure_file (cmake.config.h.in config.h @ONLY)
include_directories (${CMAKE_CURRENT_BINARY_DIR})

if (BUILD_SHARED_LIBS)
  add_definitions (-DFFTW_DLL)
endif ()

add_library (${fftw3_lib} ${SOURCEFILES})
target_include_directories (${fftw3_lib} INTERFACE $<INSTALL_INTERFACE:include>)
if (MSVC)
  target_compile_definitions (${fftw3_lib} PRIVATE /bigobj)
endif ()
if (HAVE_SSE)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE_FLAG})
endif ()
if (HAVE_SSE2)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE2_FLAG})
endif ()
if (HAVE_AVX)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX_FLAG})
endif ()
if (HAVE_AVX2)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX2_FLAG})
endif ()
if (HAVE_FMA)
  target_compile_options (${fftw3_lib} PRIVATE ${FMA_FLAG})
endif ()
if (HAVE_LIBM)
  target_link_libraries (${fftw3_lib} m)
endif ()

set (subtargets ${fftw3_lib})

if (Threads_FOUND)
  if (WITH_COMBINED_THREADS)
    target_link_libraries (${fftw3_lib} ${CMAKE_THREAD_LIBS_INIT})
  else ()
    add_library (${fftw3_lib}_threads ${fftw_threads_SOURCE})
    target_include_directories (${fftw3_lib}_threads INTERFACE $<INSTALL_INTERFACE:include>)
    target_link_libraries (${fftw3_lib}_threads ${fftw3_lib})
    target_link_libraries (${fftw3_lib}_threads ${CMAKE_THREAD_LIBS_INIT})
    list (APPEND subtargets ${fftw3_lib}_threads)
  endif ()
endif ()

if (OPENMP_FOUND)
  add_library (${fftw3_lib}_omp ${fftw_omp_SOURCE})
  target_include_directories (${fftw3_lib}_omp INTERFACE $<INSTALL_INTERFACE:include>)
  target_link_libraries (${fftw3_lib}_omp ${fftw3_lib})
  target_link_libraries (${fftw3_lib}_omp ${CMAKE_THREAD_LIBS_INIT})
  list (APPEND subtargets ${fftw3_lib}_omp)
  target_compile_options (${fftw3_lib}_omp PRIVATE ${OpenMP_C_FLAGS})
endif ()

foreach(subtarget ${subtargets})

=== debian/changelog ===
fftw3 (3.3.8-2ubuntu8) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 14:51:59 +0100

fftw3 (3.3.8-2ubuntu7) impish; urgency=medium

  * enable building libfftw3-long3 on riscv64 (LP: #1939516)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 06 Aug 2021 16:59:02 +0200

fftw3 (3.3.8-2ubuntu6) groovy; urgency=medium

  * Skip testsuite for i386-as-amd64 autopkgtest runners, failing to make
    crossbuilding work in the autopkgtest testbed.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 05 Jun 2020 10:58:15 +0100

fftw3 (3.3.8-2ubuntu4) groovy; urgency=medium

  * Fixup testsuite for i386-as-amd64 autopkgtest runners.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 10:57:14 +0100

fftw3 (3.3.8-2ubuntu2) groovy; urgency=medium

  * Enable mpi everywhere, but i386.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 29 May 2020 14:43:21 +0100

fftw3 (3.3.8-2ubuntu1) focal; urgency=medium

  * debian/rules: Disable Neon for armhf single precision builds to avoid
    crashes. It's unclear if this is an fftw3 internal bug in its code
    generator (which fftw3 does by hand) or related to gcc changes in recent
    years. But certainly disabling Neon avoids the crashes. (LP: #1843733)

 -- Daniel van Vugt <daniel.van.vugt@canonical.com>  Sat, 30 Nov 2019 23:40:05 +0100

fftw3 (3.3.8-2) unstable; urgency=medium

  * Add fftw3.info-1 and fftw3.info-2 to libfftw3-doc (closes: #880618)
  * Bump Standards-Version to 4.2.1

 -- Paul Brossier <piem@debian.org>  Mon, 10 Sep 2018 22:35:56 +0200

fftw3 (3.3.8-1) unstable; urgency=medium

  * New upstream release
  * remove libfftw3-dbg in favor of automatic dbgsym package (Closes: #892248)
  * add arm64 mips64el ppc64el to libfftw3-long dependency
    of libfftw3-dev (Closes: #902342)
  * update Vcs urls
  * bump standards-version to 4.1.4
  * replace Priority extra with optional

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Mon, 25 Jun 2018 22:02:59 +0200

=== debian/control ===
Source: fftw3
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>,
           Julian Taylor <jtaylor.debian@googlemail.com>
Build-Depends: chrpath,
               debhelper (>= 9),
               dh-autoreconf,
               dpkg (>= 1.16.0),
               gfortran,
               mpi-default-dev [!i386],
               texinfo
Build-Depends-Indep: ghostscript (>> 8.63), transfig
Vcs-Git: https://salsa.debian.org/science-team/fftw3.git
Vcs-Browser: https://salsa.debian.org/science-team/fftw3
Homepage: http://fftw.org
Standards-Version: 4.2.1

Package: libfftw3-3
Architecture: any
Depends: libfftw3-double3 (=${binary:Version}),
         libfftw3-long3 (=${binary:Version}) [amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el riscv64 s390 s390x sparc x32],
         libfftw3-single3 (=${binary:Version}),
         ${misc:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Provides: fftw3
Replaces: fftw3
Conflicts: fftw3
Multi-Arch: same
Section: oldlibs
Description: Library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast.
 This package is a transitional package depending on the packages containing
 the single and double precision libraries.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-single3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Single precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for single precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-double3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Double precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-long3
Architecture: amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el riscv64 s390 s390x sparc x32
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Long precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for long double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-quad3
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms - Quad precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for quad precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Replaces: libfftw3-dev (<< 3.3.2-1)
Breaks: libfftw3-dev (<< 3.3.2-1)
Description: Library for computing Fast Fourier Transforms - Tools
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast.
 .
 This package contains the wisdom management tools.

Package: libfftw3-mpi3
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-mpi-dev
Multi-Arch: same
Description: MPI Library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 versions of the fftw libraries in single, double and long double precisions.
 Note that on some architectures double is the same as long double in which
 case there is no long double library.
 .
 To get the static library and the header files, you need to install
 libfftw3-mpi-dev. For documentation, see libfftw3-doc.

Package: libfftw3-dev
Architecture: any
Section: libdevel
Depends: libfftw3-bin (=${binary:Version}),
         libfftw3-double3 (=${binary:Version}),
         libfftw3-long3 (=${binary:Version}) [amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el riscv64 s390 s390x sparc x32],
         libfftw3-quad3 (=${binary:Version}) [amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32],
         libfftw3-single3 (=${binary:Version}),
         ${misc:Depends}
Suggests: libfftw3-doc
Provides: fftw3-dev
Replaces: fftw3-dev
Conflicts: fftw3-dev
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries.
 For documentation, see libfftw3-doc.

Package: libfftw3-mpi-dev
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Section: libdevel
Depends: libfftw3-mpi3 (=${binary:Version}), ${misc:Depends}
Suggests: libfftw3-doc
Multi-Arch: same
Description: MPI Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries for the
 mpi libraries. For documentation, see libfftw3-doc.

Package: libfftw3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libfftw3-3
Provides: fftw3-doc
Replaces: fftw3-doc
Conflicts: fftw3-doc
Multi-Arch: foreign
Description: Documentation for fftw version 3
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the documentation for
 the fftw3 library.

=== debian/rules ===
#!/usr/bin/make -f

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

ifeq (libfftw3-quad3,$(findstring libfftw3-quad3, $(shell dh_listpackages)))
QUAD := quad
else
QUAD :=
endif
ifeq (libfftw3-long3,$(findstring libfftw3-long3, $(shell dh_listpackages)))
LONG := long
else
LONG :=
endif
PREC := single double $(LONG) $(QUAD)

# old configure stuff needs a --target
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  archconfflags := $(archconfflags) --build $(DEB_HOST_GNU_TYPE)
else
  archconfflags := $(archconfflags) --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#--enable-k7             enable AMD K7 optimizations, including 3dNow! (single precision)
#--enable-sse            enable SSE optimizations (single precision only)
#--enable-sse2           enable SSE2 optimizations (double precision only)
#--enable-altivec        enable Altivec optimizations (single precision only)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
ifneq (,$(filter $(ARCHITECTURE), i386 amd64 x32))
	archconfflags_single := --enable-sse --enable-avx
	archconfflags_double := --enable-sse2 --enable-avx
endif
# no avx support in debian yet see #674760
ifneq (,$(filter $(ARCHITECTURE), kfreebsd-i386 kfreebsd-amd64))
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(ARCHITECTURE), powerpc)
	archconfflags_single := --enable-altivec
endif
ifneq (,$(filter $(ARCHITECTURE), armhf))
	archconfflags_single := --with-slow-timer
endif
ifneq (,$(filter $(ARCHITECTURE), arm64))
	archconfflags_single := --enable-neon --with-slow-timer
endif
endif

ifneq (,$(findstring nog77,$(DEB_BUILD_OPTIONS)))
	archconfflags := $(archconfflags) F77="gfortran" 
else
	archconfflags := $(archconfflags) F77="gfortran -ff2c"
endif

# Enable mpi everywhere, but i386
ifeq (,$(filter $(ARCHITECTURE), i386))
archconfflags := $(archconfflags) --enable-mpi
endif

SETCFLAGS := CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'

# common configure options
archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) MPILIBS="$(shell mpicc --showme:link)"

build-arch:
	dh_autoreconf
	# single precision
	$(SETCFLAGS) ./configure --enable-single $(archconfflags) $(archconfflags_single)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-single
	#
	# double precision
	$(SETCFLAGS) ./configure $(archconfflags) $(archconfflags_double)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
	# long double precision
ifeq (long,$(LONG))
	$(SETCFLAGS) ./configure --enable-long-double $(archconfflags)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-long;
endif
ifeq (quad,$(QUAD))
	# quad precision
	$(SETCFLAGS) ./configure $(archconfflags) --enable-quad-precision --disable-mpi
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-quad
endif
	touch build-arch

build-indep:
	-(cd doc ; $(MAKE) -j1 -k clean)
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	[ -f doc/Makefile ] || ./configure
	cd doc/FAQ && $(MAKE) -j1 fftw-faq.html fftw-faq.ascii
	cd doc && $(MAKE) -j1 && $(MAKE) -j1 html
	touch build-indep

build: build-stamp
build-stamp: build-arch

clean: clean1st
clean1st:
	dh_testdir
	dh_testroot
	rm -f build-arch build-indep
	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f *.pc tools/*wisdom tools/*wisdom.1
	-find . -name "*.la" | xargs -r rm -f
	-rm -f test_long_long-double
	-rm -f config.cache config.status config.log
	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long debian/tmp-quad
	rm -f mpi/mpi-bench
	chmod -R g-s .
	dh_autoreconf_clean
	dh_clean

binary-indep: build-indep
	# build fftw3-doc
	dh_prep -i
	dh_testdir
	dh_testroot
	dh_installdocs -i README NEWS
	dh_installinfo -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

binary-arch: build-arch
	# build fftw3
	dh_prep -a
	dh_installdocs -a -A README NEWS debian/README.Debian
	dh_installchangelogs -a -XChangeLog
	dh_installexamples -a
	dh_installdirs -a
	set -e && for s in $(PREC); do \
	  dh_install -plibfftw3-bin --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-$${s}3 --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-dev --sourcedir=debian/tmp-$$s; \
	  if [ $$s != "quad" ]; then \
	    dh_install -plibfftw3-mpi3 --sourcedir=debian/tmp-$$s; \
	    dh_install -plibfftw3-mpi-dev --sourcedir=debian/tmp-$$s; \
	    rm -f debian/libfftw3-$${s}3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*; \
	  fi; \
	done
	rm -f debian/libfftw3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi* \
	   debian/libfftw3-dev/usr/include/*mpi*
	-chrpath --delete debian/libfftw3-mpi3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*so*

	find $(CURDIR)/debian/libfftw3-dev -type d -empty -delete

	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	# 3.3.5 added new symbols, tighten shlibs for partial upgrades
	set -e && for s in $(PREC); do \
	  dh_makeshlibs -plibfftw3-$${s}3 -V "libfftw3-$${s}3 (>= 3.3.5)"; \
	done
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean
.NOTPARALLEL:

=== debian/tests/control ===
Tests: tools
Depends: libfftw3-bin

Tests: build
Depends: build-essential, libfftw3-dev
Restrictions: skippable

## fftw3 3.3.10

=== debian/changelog ===
fftw3 (3.3.10-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:58:26 +0000

fftw3 (3.3.10-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:24:56 +0000

fftw3 (3.3.10-1ubuntu1) lunar; urgency=medium

  * Sync with Debian. Remaining changes:
    - Disable neon for armhf single precision builds to avoid crashes
      (LP: #1843733)
    - Skip 'build' autopkgtest on i386

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 08 Feb 2023 16:34:53 -0500

fftw3 (3.3.10-1) unstable; urgency=medium

  * Team upload.

  [ Steffen Moeller ]
  * d/copyright: format changed to be machine readable.

  [ Jelmer Vernooĳ ]
  * Trim trailing whitespace.

  [ Sébastien Villemot ]
  * Rewrite d/rules using dh sequencer.
    By the way, fix some missing checks for DEB_BUILD_OPTIONS=nocheck
  * Bump to debhelper compat level 13
    - dh_autoreconf run by default
    - doc installed under /u/s/doc/libfftw-dev/
    - dh_makeshlibs now defaults to -V
  * d/upstream/metadata:
    - move to correct location
    - add more fields
  * Remove useless libfftw3-dev.dirs
  * d/copyright: update copyright years
  * d/control:
    + remove obsolete Breaks/Conflicts/Replaces/Provides
    + remove obsolete versioned Build-Depends on dpkg and ghostscript
    + remove useless Build-Depends on dh-autoreconf
    + add Rules-Requires-Root: no
  * d/tests/{build,tools}: replace $ADTTMP with $AUTOPKGTEST_TMP
  * Reword abstract in d/libfftw3-doc.doc-base.fftw3-faq to make
    lintian happy
  * Remove transitional package libfftw3-3, it no longer has
    reverse dependencies

  [ Boyuan Yang ]
  * New upstream release 3.3.10.
  * debian/watch: Monitor with https instead of ftp.
  * bump Standards-Version to 4.6.1.
  * Apply patch from Ubuntu:

  [ Heinrich Schuchardt ]
  * enable building libfftw3-long3 on riscv64 (LP: #1939516)

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.

  [ Andreas Tille ]
  * Fix Maintainer name of Debian Science team (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Add salsa-ci file (routine-update)
  * Set hardening options
  * lintian-overrides (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 17:40:47 +0100

=== debian/control ===
Source: fftw3
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>,
           Julian Taylor <jtaylor.debian@googlemail.com>
Section: libs
Priority: optional
Build-Depends: chrpath,
               debhelper-compat (= 13),
               gfortran,
               mpi-default-dev,
               texinfo
Build-Depends-Indep: ghostscript
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/fftw3
Vcs-Git: https://salsa.debian.org/science-team/fftw3.git
Homepage: https://fftw.org
Rules-Requires-Root: no

Package: libfftw3-single3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-bin,
          libfftw3-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Library for computing Fast Fourier Transforms - Single precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for single precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-double3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-bin,
          libfftw3-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Library for computing Fast Fourier Transforms - Double precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-long3
Architecture: amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el riscv64 s390 s390x sparc x32
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-bin,
          libfftw3-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Library for computing Fast Fourier Transforms - Long precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for long double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-quad3
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-bin,
          libfftw3-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Library for computing Fast Fourier Transforms - Quad precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for quad precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library for computing Fast Fourier Transforms - Tools
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast.
 .
 This package contains the wisdom management tools.

Package: libfftw3-mpi3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-mpi-dev
Pre-Depends: ${misc:Pre-Depends}
Description: MPI Library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 versions of the fftw libraries in single, double and long double precisions.
 Note that on some architectures double is the same as long double in which
 case there is no long double library.
 .
 To get the static library and the header files, you need to install
 libfftw3-mpi-dev. For documentation, see libfftw3-doc.

Package: libfftw3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libfftw3-bin (=${binary:Version}),
         libfftw3-double3 (=${binary:Version}),
         libfftw3-long3 (=${binary:Version}) [amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el riscv64 s390 s390x sparc x32],
         libfftw3-quad3 (=${binary:Version}) [amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32],
         libfftw3-single3 (=${binary:Version}),
         ${misc:Depends}
Suggests: libfftw3-doc
Description: Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries.
 For documentation, see libfftw3-doc.

Package: libfftw3-mpi-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libfftw3-mpi3 (=${binary:Version}),
         ${misc:Depends}
Suggests: libfftw3-doc
Description: MPI Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries for the
 mpi libraries. For documentation, see libfftw3-doc.

Package: libfftw3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libfftw3-dev
Description: Documentation for fftw version 3
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the documentation for
 the fftw3 library.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq (libfftw3-quad3,$(findstring libfftw3-quad3, $(shell dh_listpackages)))
QUAD := quad
else
QUAD :=
endif
ifeq (libfftw3-long3,$(findstring libfftw3-long3, $(shell dh_listpackages)))
LONG := long
else
LONG :=
endif
PREC := single double $(LONG) $(QUAD)

# old configure stuff needs a --target
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  archconfflags := $(archconfflags) --build $(DEB_HOST_GNU_TYPE)
else
  archconfflags := $(archconfflags) --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#--enable-k7             enable AMD K7 optimizations, including 3dNow! (single precision)
#--enable-sse            enable SSE optimizations (single precision only)
#--enable-sse2           enable SSE2 optimizations (double precision only)
#--enable-altivec        enable Altivec optimizations (single precision only)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH), i386 amd64 x32))
	archconfflags_single := --enable-sse --enable-avx
	archconfflags_double := --enable-sse2 --enable-avx
endif
# no avx support in debian yet see #674760
ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(DEB_HOST_ARCH), powerpc)
	archconfflags_single := --enable-altivec
endif
ifneq (,$(filter $(ARCHITECTURE), armhf))
	archconfflags_single := --with-slow-timer
endif
ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
	archconfflags_single := --enable-neon --with-slow-timer
endif
endif

ifneq (,$(findstring nog77,$(DEB_BUILD_OPTIONS)))
	archconfflags := $(archconfflags) F77="gfortran"
else
	archconfflags := $(archconfflags) F77="gfortran -ff2c"
endif

# common configure options
archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --enable-mpi --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) MPILIBS="$(shell mpicc --showme:link)"

%:
	dh $@

override_dh_auto_build-arch:
	# single precision
	./configure --enable-single $(archconfflags) $(archconfflags_single)
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-single
	#
	# double precision
	./configure $(archconfflags) $(archconfflags_double)
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
	# long double precision
ifeq (long,$(LONG))
	./configure --enable-long-double $(archconfflags)
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-long;
endif
ifeq (quad,$(QUAD))
	# quad precision
	./configure $(archconfflags) --enable-quad-precision --disable-mpi
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-quad
endif

override_dh_auto_build-indep:
	-(cd doc ; $(MAKE) -j1 -k clean)
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	[ -f doc/Makefile ] || ./configure
	cd doc/FAQ && $(MAKE) -j1 fftw-faq.html fftw-faq.ascii
	cd doc && $(MAKE) -j1 && $(MAKE) -j1 html

# Those are actually handled by override_dh_auto_build
override_dh_auto_configure:
override_dh_auto_test:
override_dh_auto_install:

override_dh_auto_clean:
	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f *.pc tools/*wisdom tools/*wisdom.1
	-find . -name "*.la" | xargs -r rm -f
	-rm -f test_long_long-double
	-rm -f config.cache config.status config.log
	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long debian/tmp-quad
	rm -f mpi/mpi-bench
	chmod -R g-s .

override_dh_installdocs-arch:
	dh_installdocs -A README NEWS debian/README.Debian

override_dh_installchangelogs-indep:
	dh_installchangelogs ChangeLog

override_dh_installchangelogs-arch:
	dh_installchangelogs -XChangeLog

override_dh_install-arch:
	set -e && for s in $(PREC); do \
	  dh_install -plibfftw3-bin --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-$${s}3 --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-dev --sourcedir=debian/tmp-$$s; \
	  if [ $$s != "quad" ]; then \
	    dh_install -plibfftw3-mpi3 --sourcedir=debian/tmp-$$s; \
	    dh_install -plibfftw3-mpi-dev --sourcedir=debian/tmp-$$s; \
	    rm debian/libfftw3-$${s}3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*; \
	  fi; \
	done
	rm debian/libfftw3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi* \
	   debian/libfftw3-dev/usr/include/*mpi*
	chrpath --delete debian/libfftw3-mpi3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*so*

	find $(CURDIR)/debian/libfftw3-dev -type d -empty -delete

=== debian/watch ===
version=4

# circumventing an apparent uscan but that introduces an extra "." or the non-matching (-pl[0-9]+)?)
opts="uversionmangle=s/-pl/p/,uversionmangle=s/.$//" \
 https://fftw.org/pub/fftw/ fftw-([\.0-9]+(-pl[0-9]+)?).tar\.gz
